//+------------------------------------------------------------------+
//|                                                 i_Pribilnost.mq4 |
//|                      Copyright  2011, todem ()           |
//|                                                 todem5@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, todem ()"
#property link      "todem5@gmail.com"

#property indicator_chart_window
extern double lot=0.1;
extern int magic=1;
double chis, znam, koef;
int MG;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (magic==0) {MG=0;}
   else if (magic==1) {MG=AccountNumber()+StringGetChar(Symbol(),0)+StringGetChar(Symbol(),3)+Period();}
        else MG=magic;
   
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("L1");
   ObjectDelete("L2");
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   if (!IsOptimization() && !IsTesting() && !IsVisualMode()) {
   ObjectCreate("L1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("L1", " : " + DoubleToStr(koef,2)+", MG: " + DoubleToStr(MG,0), 9, "Verdana", Yellow);
   ObjectSet("L1", OBJPROP_CORNER, 3);
   ObjectSet("L1", OBJPROP_XDISTANCE, 5);
   ObjectSet("L1", OBJPROP_YDISTANCE, 30);
      
   ObjectCreate("L2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("L2", ": " + DoubleToStr(lot,2)+ ", :" + DoubleToStr(chis,2) + ", :" + DoubleToStr(znam,2), 9, "Verdana", Yellow);
   ObjectSet("L2", OBJPROP_CORNER, 3);
   ObjectSet("L2", OBJPROP_XDISTANCE, 5);
   ObjectSet("L2", OBJPROP_YDISTANCE, 45);
   }
   int b=IndicatorCounted();
  
   int i, k=OrdersTotal(), k2=OrdersHistoryTotal();
   if (b>0) {
      chis=0; znam=0;
      for (i=k-1; i>=0; i--) {
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            if (OrderType()==OP_BUY /*&& OrderMagicNumber()==MG*/) {
               if (OrderProfit()>0) chis+=OrderProfit();
               if (OrderProfit()<0) znam+=OrderProfit();
            }
            if (OrderType()==OP_SELL /*&& OrderMagicNumber()==MG*/) {
               if (OrderProfit()>0) chis+=OrderProfit();
               if (OrderProfit()<0) znam+=OrderProfit();
            }
         }
      }
      for (i=k2-1; i>0; i--) {
         if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderType()==OP_BUY /*&& OrderMagicNumber()==MG*/) {
               if (OrderProfit()>0) chis+=OrderProfit();
               if (OrderProfit()<0) znam+=OrderProfit();
            }
            if (OrderType()==OP_SELL /*&& OrderMagicNumber()==MG*/) {
               if (OrderProfit()>0) chis+=OrderProfit();
               if (OrderProfit()<0) znam+=OrderProfit();
            }
         }
      }
      
      if (znam<0) znam=-1*znam;
      if (znam!=0) koef=chis/znam;
      /*if (znam==0) {
         chis=chis+1;
         znam=1;
         koef=chis/znam;
         }*/
   }         
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+